commit 052b2df6f0ecd1e5b55056911b16bca8b31ef7df
Author: Patrick Palka <ppalka@redhat.com>
Date:   Thu Oct 7 16:02:54 2021

    c++: variadic ttp constraint subsumption [PR99904]
    
    Here we're crashing when level-lowering the variadic constraint C<Ts...>
    on the template template parameter TT because tsubst_pack_expansion expects
    processing_template_decl to be set during a partial substitution.
    
            PR c++/99904
    
    gcc/cp/ChangeLog:
    
            * pt.c (is_compatible_template_arg): Set processing_template_decl
            around tsubst_constraint_info.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp2a/concepts-ttp4.C: New test.
    
    (cherry picked from commit 2e6e0d86a06389056d0e7fecc99c547420ad787a)

diff --git a/gcc/cp/pt.c b/gcc/cp/pt.c
index 9e026699620..5454bfca827 100644
--- a/gcc/cp/pt.c
+++ b/gcc/cp/pt.c
@@ -8225,8 +8225,10 @@ is_compatible_template_arg (tree parm, tree arg)
     {
       tree aparms = DECL_INNERMOST_TEMPLATE_PARMS (arg);
       new_args = template_parms_level_to_args (aparms);
+      ++processing_template_decl;
       parm_cons = tsubst_constraint_info (parm_cons, new_args,
 					  tf_none, NULL_TREE);
+      --processing_template_decl;
       if (parm_cons == error_mark_node)
         return false;
     }
diff --git a/gcc/testsuite/g++.dg/cpp2a/concepts-ttp4.C b/gcc/testsuite/g++.dg/cpp2a/concepts-ttp4.C
new file mode 100644
index 00000000000..cf3e71ea974
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/concepts-ttp4.C
@@ -0,0 +1,9 @@
+// PR c++/99904
+// { dg-do compile { target c++20 } }
+
+template<class... Ts> concept C = (Ts::value && ...);
+template<class... Ts> requires C<Ts...> struct A;
+template<class T> requires true struct B;
+template<template<class... Ts> requires C<Ts...> class TT> struct S;
+using ty1 = S<A>;
+using ty2 = S<B>; // { dg-error "constraint" } TT's constraints don't subsume B's

